summaryrefslogtreecommitdiffstats
path: root/veracrypt/build
diff options
context:
space:
mode:
author Eric Hameleers <alien@slackware.com>2015-07-13 19:38:48 +0000
committer Eric Hameleers <alien@slackware.com>2015-07-13 19:38:48 +0000
commit4b3611af5c6426d78d5ef824931eeaaff6a1177e (patch)
tree2f9d2a2ef2b323a499dcf0ccd10a01f20536a316 /veracrypt/build
parent924af28ec0b087c8700a26fd2393f7fc8fe0e8d1 (diff)
downloadasb-4b3611af5c6426d78d5ef824931eeaaff6a1177e.tar.gz
asb-4b3611af5c6426d78d5ef824931eeaaff6a1177e.tar.xz
Initial revision
Diffstat (limited to 'veracrypt/build')
-rw-r--r--veracrypt/build/patches/veracrypt_no_makeself.patch12
-rw-r--r--veracrypt/build/slack-desc19
-rwxr-xr-xveracrypt/build/veracrypt.SlackBuild319
3 files changed, 350 insertions, 0 deletions
diff --git a/veracrypt/build/patches/veracrypt_no_makeself.patch b/veracrypt/build/patches/veracrypt_no_makeself.patch
new file mode 100644
index 00000000..5982fe72
--- /dev/null
+++ b/veracrypt/build/patches/veracrypt_no_makeself.patch
@@ -0,0 +1,12 @@
+diff -aur clean/veracrypt/src/Main/Main.make src/veracrypt/src/Main/Main.make
+--- clean/Main/Main.make 2014-10-14 19:12:32.000000000 +0300
++++ src/Main/Main.make 2014-10-14 19:13:27.330705412 +0300
+@@ -206,7 +206,6 @@
+ rm -fr $(PWD)/Setup/Linux/packaging
+ mkdir -p $(PWD)/Setup/Linux/packaging
+ cp $(INTERNAL_INSTALLER_NAME) $(PWD)/Setup/Linux/packaging/.
+- makeself $(PWD)/Setup/Linux/packaging $(PWD)/Setup/Linux/$(INSTALLER_NAME) "VeraCrypt $(TC_VERSION) Installer" ./$(INTERNAL_INSTALLER_NAME)
+
+ endif
+
+
diff --git a/veracrypt/build/slack-desc b/veracrypt/build/slack-desc
new file mode 100644
index 00000000..10474ad4
--- /dev/null
+++ b/veracrypt/build/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description. Line
+# up the first '|' above the ':' following the base package name, and the '|'
+# on the right side marks the last column you can put a character in. You must
+# make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+veracrypt: veracrypt (free disk encryption software based on TrueCrypt)
+veracrypt:
+veracrypt: VeraCrypt is free disk encryption software based on TrueCrypt.
+veracrypt: It adds enhanced security to the algorithms used for system and
+veracrypt: partitions encryption making it immune to new developments in
+veracrypt: brute-force attacks. This enhanced security adds some delay only to
+veracrypt: the opening of encrypted partitions without any performance impact to
+veracrypt: the application use phase. This is acceptable to the data owner but
+veracrypt: makes it harder for an attacker to gain access to the encrypted data.
+veracrypt:
+veracrypt: veracrypt home: https://veracrypt.codeplex.com/
diff --git a/veracrypt/build/veracrypt.SlackBuild b/veracrypt/build/veracrypt.SlackBuild
new file mode 100755
index 00000000..52d04614
--- /dev/null
+++ b/veracrypt/build/veracrypt.SlackBuild
@@ -0,0 +1,319 @@
+#!/bin/sh
+# $Id$
+# Copyright 2015 Eric Hameleers, Eindhoven, NL
+# All rights reserved.
+#
+# Permission to use, copy, modify, and distribute this software for
+# any purpose with or without fee is hereby granted, provided that
+# the above copyright notice and this permission notice appear in all
+# copies.
+#
+# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+# USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+# -----------------------------------------------------------------------------
+#
+# Slackware SlackBuild script
+# ===========================
+# By: Eric Hameleers <alien@slackware.com>
+# For: veracrypt
+# Descr: free disk encryption software based on TrueCrypt
+# URL: https://veracrypt.codeplex.com/
+# Build needs:
+# Needs:
+# Changelog:
+# 1.0f_2-1: 13/Jul/2015 by Eric Hameleers <alien@slackware.com>
+# * Initial build.
+#
+# Run 'sh veracrypt.SlackBuild' to build a Slackware package.
+# The package (.t?z) and .txt file as well as build logs are created in /tmp .
+# Install the package using 'installpkg' or 'upgradepkg --install-new'.
+#
+# -----------------------------------------------------------------------------
+
+PRGNAM=veracrypt
+SRCVER=${SRCVER:-"1.0f-2"}
+VERSION=$(echo $SRCVER |tr - _)
+BUILD=${BUILD:-1}
+NUMJOBS=${NUMJOBS:-" -j4 "}
+TAG=${TAG:-alien}
+
+WX=${WX:-3.0.2} # for the GUI
+
+DOCS="License.txt Readme.txt Release/Setup*/VeraCrypt*Guide.pdf"
+
+# Where do we look for sources?
+SRCDIR=$(cd $(dirname $0); pwd)
+
+# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
+TMP=${TMP:-/tmp/build}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+SOURCE[0]="$SRCDIR/${PRGNAM}_${SRCVER}_Source.tar.bz2"
+SRCURL[0]="http://download-codeplex.sec.s-msft.com/Download/Release?ProjectName=veracrypt&DownloadId=1372350&FileTime=130728237333300000&Build=21028"
+
+SOURCE[1]="$SRCDIR/wxWidgets-${WX}.tar.bz2"
+SRCURL[1]="http://downloads.sourceforge.net/wxwindows/wxWidgets-${WX}.tar.bz2"
+
+##
+## --- with a little luck, you won't have to edit below this point --- ##
+##
+
+# You can use your own private machine.conf file to overrule machine defaults:
+if [ -e $SRCDIR/machine.conf ]; then
+ . $SRCDIR/machine.conf
+elif [ -e /etc/slackbuild/machine.conf ]; then
+ . /etc/slackbuild/machine.conf
+else
+ # Automatically determine the architecture we're building on:
+ MARCH=$( uname -m )
+ if [ -z "$ARCH" ]; then
+ case "$MARCH" in
+ i?86) export ARCH=i486 ;;
+ armv7hl) export ARCH=$MARCH ;;
+ armv6hl) export ARCH=$MARCH ;;
+ arm*) export ARCH=arm ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) export ARCH=$MARCH ;;
+ esac
+ fi
+ # Set CFLAGS/CXXFLAGS and LIBDIRSUFFIX:
+ case "$ARCH" in
+ i486) SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ x86_64) SLKCFLAGS="-O2 -fPIC"
+ SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
+ ;;
+ armv7hl) SLKCFLAGS="-O2 -march=armv7-a -mfpu=vfpv3-d16"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ armv6hl) SLKCFLAGS="-O2 -march=armv6 -mfpu=vfp -mfloat-abi=hard"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ *) SLKCFLAGS=${SLKCFLAGS:-"O2"}
+ SLKLDFLAGS=${SLKLDFLAGS:-""}; LIBDIRSUFFIX=${LIBDIRSUFFIX:-""}
+ ;;
+ esac
+fi
+
+case "$ARCH" in
+ arm*) TARGET=$ARCH-slackware-linux-gnueabi ;;
+ *) TARGET=$ARCH-slackware-linux ;;
+esac
+
+# Exit the script on errors:
+set -e
+trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
+# Catch unitialized variables:
+set -u
+P1=${1:-1}
+
+# Save old umask and set to 0022:
+_UMASK_=$(umask)
+umask 0022
+
+# Create working directories:
+mkdir -p $OUTPUT # place for the package to be saved
+mkdir -p $TMP/tmp-$PRGNAM # location to build the source
+mkdir -p $PKG # place for the package to be built
+rm -rf $PKG/* # always erase old package's contents
+rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
+rm -rf $OUTPUT/{checkout,configure,make,install,error,makepkg,patch}-$PRGNAM.log
+ # remove old log files
+
+# Source file availability:
+for (( i = 0; i < ${#SOURCE[*]}; i++ )) ; do
+ if ! [ -f ${SOURCE[$i]} ]; then
+ echo "Source '$(basename ${SOURCE[$i]})' not available yet..."
+ # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
+ [ -w "$SRCDIR" ] || SOURCE[$i]="$OUTPUT/$(basename ${SOURCE[$i]})"
+ if [ -f ${SOURCE[$i]} ]; then echo "Ah, found it!"; continue; fi
+ if ! [ "x${SRCURL[$i]}" == "x" ]; then
+ echo "Will download file to $(dirname $SOURCE[$i])"
+ lynx -dump "${SRCURL[$i]}" > "${SOURCE[$i]}" || true
+ if [ $? -ne 0 -o ! -s "${SOURCE[$i]}" ]; then
+ echo "Fail to download '$(basename ${SOURCE[$i]})'. Aborting the build."
+ mv -f "${SOURCE[$i]}" "${SOURCE[$i]}".FAIL
+ exit 1
+ fi
+ else
+ echo "File '$(basename ${SOURCE[$i]})' not available. Aborting the build."
+ exit 1
+ fi
+ fi
+done
+
+if [ "$P1" == "--download" ]; then
+ echo "Download complete."
+ exit 0
+fi
+
+# --- PACKAGE BUILDING ---
+
+echo "++"
+echo "|| $PRGNAM-$VERSION"
+echo "++"
+
+cd $TMP/tmp-$PRGNAM
+echo "Extracting the source archive(s) for $PRGNAM..."
+for (( i = 0; i < ${#SOURCE[*]}; i++ )) ; do
+ tar -xvf ${SOURCE[$i]}
+done
+
+chown -R root:root .
+chmod -R u+w,go+r-w,a+rX-st .
+
+cd src
+
+# We do not need a self-extracting installer:
+cat $SRCDIR/patches/veracrypt_no_makeself.patch | patch -p1 --verbose \
+ 2>&1 | tee $OUTPUT/patch-${PRGNAM}.log
+
+echo Building ...
+export LDFLAGS="$SLKLDFLAGS"
+export CXXFLAGS="$SLKCFLAGS"
+export CFLAGS="$SLKCFLAGS"
+
+# First build a static wxGTK, then build truecrypt:
+make WXSTATIC=1 WX_ROOT=$(cd ../wxWidgets-$WX; pwd) VERBOSE=1 wxbuild \
+ 2>&1 | tee $OUTPUT/make-${PRGNAM}_wx.log
+make WXSTATIC=1 LFLAGS="-ldl" VERBOSE=1 \
+ 2>&1 | tee $OUTPUT/make-${PRGNAM}.log
+
+# Install the GUI/console combined binary:
+mkdir -p $PKG/usr/bin
+install -m0755 Main/${PRGNAM} $PKG/usr/bin/${PRGNAM}
+
+# Also build a console-only version that does not depend on any GUI libs:
+make clean
+make NOGUI=1 WXSTATIC=1 WX_ROOT=$(cd ../wxWidgets-$WX; pwd) VERBOSE=1 wxbuild \
+ 2>&1 | tee $OUTPUT/make-${PRGNAM}-nox_wx.log
+make NOGUI=1 WXSTATIC=1 LFLAGS="-ldl" VERBOSE=1 \
+ 2>&1 | tee $OUTPUT/make-${PRGNAM}-nox.log
+
+# Install the console-only binary:
+mkdir -p $PKG/usr/bin
+install -m0755 Main/${PRGNAM} $PKG/usr/bin/${PRGNAM}-nox
+
+# Add a desktop entry:
+mkdir -p $PKG/usr/share/pixmaps
+install -m0644 $SRCDIR/${PRGNAM}.png $PKG/usr/share/pixmaps/${PRGNAM}.png
+
+mkdir -p $PKG/usr/share/applications
+cat << EOT > $PKG/usr/share/applications/${PRGNAM}.desktop
+[Desktop Entry]
+Type=Application
+TryExec=${PRGNAM}
+Exec=${PRGNAM}
+Icon=${PRGNAM}
+Comment=Disk encryption software
+Terminal=false
+Name=VeraCrypt
+StartupNotify=true
+Categories=System;
+EOT
+
+# Add this to the doinst.sh:
+mkdir -p $PKG/install
+cat <<EOINS >> $PKG/install/doinst.sh
+# Handle the incoming configuration files:
+config() {
+ for infile in \$1; do
+ NEW="\$infile"
+ OLD="\`dirname \$NEW\`/\`basename \$NEW .new\`"
+ # If there's no config file by that name, mv it over:
+ if [ ! -r \$OLD ]; then
+ mv \$NEW \$OLD
+ elif [ "\`cat \$OLD | md5sum\`" = "\`cat \$NEW | md5sum\`" ]; then
+ # toss the redundant copy
+ rm \$NEW
+ fi
+ # Otherwise, we leave the .new copy for the admin to consider...
+ done
+}
+
+# An example of how you handle your '.new' config files:
+#config etc/veracrypt.conf.new
+
+# Update the desktop database:
+if [ -x usr/bin/update-desktop-database ]; then
+ chroot . /usr/bin/update-desktop-database usr/share/applications > /dev/null 2>&1
+fi
+
+# Update hicolor theme cache:
+if [ -d usr/share/icons/hicolor ]; then
+ if [ -x /usr/bin/gtk-update-icon-cache ]; then
+ chroot . /usr/bin/gtk-update-icon-cache -f -t usr/share/icons/hicolor 1> /dev/null 2> /dev/null
+ fi
+fi
+
+# Update the mime database:
+if [ -x usr/bin/update-mime-database ]; then
+ chroot . /usr/bin/update-mime-database usr/share/mime >/dev/null 2>&1
+fi
+
+EOINS
+
+# Add documentation:
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
+cat $SRCDIR/$(basename $0) > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+chown -R root:root $PKG/usr/doc/$PRGNAM-$VERSION
+find $PKG/usr/doc -type f -exec chmod 644 {} \;
+
+# Compress the man page(s):
+if [ -d $PKG/usr/man ]; then
+ find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;
+ for i in $(find $PKG/usr/man -type l -name "*.?") ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+fi
+
+# Compress info pages and remove the package's dir file:
+if [ -d $PKG/usr/info ]; then
+ rm -f $PKG/usr/info/dir
+ gzip -9f $PKG/usr/info/*.info*
+ # If any info files are present, consider adding this to a doinst.sh
+ # (replacing XXXXX with whatever files you find):
+ # chroot . install-info /usr/info/XXXXX.info.gz /usr/info/dir 2> /dev/null
+fi
+
+# Strip binaries (if any):
+find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+# Add a package description:
+mkdir -p $PKG/install
+cat $SRCDIR/slack-desc > $PKG/install/slack-desc
+if [ -f $SRCDIR/doinst.sh ]; then
+ cat $SRCDIR/doinst.sh >> $PKG/install/doinst.sh
+elif [ -f $SRCDIR/doinst.sh.gz ]; then
+ zcat $SRCDIR/doinst.sh.gz >> $PKG/install/doinst.sh
+fi
+if [ -f $SRCDIR/slack-required ]; then
+ cat $SRCDIR/slack-required > $PKG/install/slack-required
+fi
+
+# Build the package:
+cd $PKG
+makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
+cd $OUTPUT
+md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz}.md5
+cd -
+cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt
+if [ -f $PKG/install/slack-required ]; then
+ cat $PKG/install/slack-required > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.dep
+fi
+
+# Restore the original umask:
+umask ${_UMASK_}
+